//weapon_RailRifle.cs

//audio
datablock AudioProfile(RailRifleFireSound)
{
   filename    = "./railRifle_fire_TEMP.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(RailRifleFullChargeSound)
{
   filename    = "./railRifle_fullyCharged.wav";
   description = AudioClosestLooping3d;
   preload = true;
};

//datablock AudioProfile(RailSlugLauncherExplodeSound)
//{
//   filename    = "./Heavy_RL_blast.wav";
//   description = AudioDefault3d;
//   preload = true;
//};
//datablock AudioProfile(RailSlugLauncherLoopSound)
//{
//  filename    = "./RailSlugLauncherLoop.wav";
//   description = AudioCloseLooping3d;
//   preload = true;
//};
//datablock AudioProfile(RailSlugLauncherBounceSound)
//{
//  filename    = "./RailSlugBounce1.wav";
//   description = AudioDefault3d;
//   preload = true;
//};


//Trail Effect//
datablock ParticleData(RailSlugTrailParticle)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 0;
   windCoefficient      = 0;
   inheritedVelFactor   = 0;
   constantAcceleration = 0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 50;
   textureName          = "base/data/particles/cloud";
   spinSpeed     = 0;
   spinRandomMin = 0;
   spinRandomMax = 0;
   colors[0]     = "0.4 0.5 1 0.2";
   colors[1]     = "0.1 0.3 1 0.0";
//   colors[2]     = "1 0.5 0 0";

   sizes[0]      = 0.2;
   sizes[1]      = 0.01;
//   sizes[2]      = 0.2;

   times[0] = 0;
   times[1] = 1;
//   times[2] = 1;

   useInvAlpha = false;
};
datablock ParticleEmitterData(RailSlugTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset = 0;
   thetaMin = 0;
   thetaMax = 180;
   phiReferenceVel = 1;
   phiVariance     = 360;
   overrideAdvance = false;
   particles = "RailSlugTrailParticle";
   uiName = "MAS Rail Slug Trail";
};


//Muzzle Flash effects//
datablock ParticleData(RailRifleMuzzleFlashParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 1;
	constantAcceleration = 0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 15;
	spinRandomMin		= -200.0;
	spinRandomMax		= 200.0;
	colors[0]     = "0.5 0.5 1.0 1.0";
	colors[1]     = "0.0 0.0 1.0 0.0";
//	colors[2]     = "0.8 0.8 0.8 0.2";
	sizes[0]      = 0.4;
	sizes[1]      = 0.01;
//	sizes[2]      = 15.0;

	times[0] = 0.0;
	times[1] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(RailRifleMuzzleFlashEmitter)
{
//	lifeTimeMS = 5;
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 60;
	velocityVariance = 2.0;
	ejectionOffset   = 0.00;
	thetaMin         = 1;
	thetaMax         = 2;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "RailRifleMuzzleFlashParticle";

//   uiName = "MAS RailSlug Explosion";
//   emitterNode = TenthEmitterNode;
};


//Charge effects//
datablock ParticleData(RailRifleChargeParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 1;
	constantAcceleration = 0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 10;
//	textureName          = "base/data/particles/star1";
	textureName			= "add-ons/projectile_radio_wave/bolt";
	spinSpeed		= 10;
	spinRandomMin		= -200.0;
	spinRandomMax		= 200.0;
	colors[0]     = "0.6 0.6 1.0 0.45";
	colors[1]     = "0.0 0.0 1.0 0.0";
//	colors[2]     = "0.8 0.8 0.8 0.2";
	sizes[0]      = 0.3;
	sizes[1]      = 0.1;
//	sizes[2]      = 15.0;

	times[0] = 0.0;
	times[1] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(RailRifleChargeEmitter)
{
//	lifeTimeMS = 5;
	ejectionPeriodMS = 5;
	periodVarianceMS = 1;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.25;
	thetaMin         = 0;
	thetaMax         = 180;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "RailRifleChargeParticle";

//   uiName = "MAS RailSlug Explosion";
//   emitterNode = TenthEmitterNode;
};

//Fully Charged effects//
datablock ParticleData(RailRifleFullChargeParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.1;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 10;
//	textureName          = "base/data/particles/star1";
	textureName			= "add-ons/projectile_radio_wave/bolt";
	spinSpeed		= 30;
	spinRandomMin		= -200.0;
	spinRandomMax		= 200.0;
	colors[0]     = "0.7 0.8 1.0 0.8";
	colors[1]     = "0.2 0.0 1.0 0.0";
//	colors[2]     = "0.8 0.8 0.8 0.2";
	sizes[0]      = 0.5;
	sizes[1]      = 0.1;
//	sizes[2]      = 15.0;

	times[0] = 0.0;
	times[1] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(RailRifleFullChargeEmitter)
{
//	lifeTimeMS = 5;
	ejectionPeriodMS = 5;
	periodVarianceMS = 1;
	ejectionVelocity = 0.1;
	velocityVariance = 0.0;
	ejectionOffset   = 0.4;
	thetaMin         = 0;
	thetaMax         = 180;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "RailRifleFullChargeParticle";

//   uiName = "MAS RailSlug Explosion";
//   emitterNode = TenthEmitterNode;
};


//Explosion effects//
datablock ParticleData(RailSlugExplosionFlashParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -1.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0;
	lifetimeMS           = 150;
	lifetimeVarianceMS   = 20;
//	textureName			= "add-ons/projectile_radio_wave/bolt";
	textureName			= "base/data/particles/star1";
	spinSpeed			= 20;
	spinRandomMin		= -200;
	spinRandomMax		= 200;
	colors[0]     = "0.4 0.5 1.0 0.4";
	colors[1]     = "0.5 0.5 0.6 0.0";
//	colors[2]     = "0.8 0.6 0.2 0";
	sizes[0]      = 10.0;
	sizes[1]      = 2.0;
//	sizes[2]      = 2.0;

	times[0] 	= 0;
	times[1] 	= 1;
//	times[2] 	= 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RailSlugExplosionFlashEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.06;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RailSlugExplosionFlashParticle";

   uiName = "MAS Rail Slug Explosion";
//   emitterNode = TenthEmitterNode;
};

/////////////////
//--Explosion--//
/////////////////
datablock ExplosionData(RailSlugExplosion)
{
//	explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";

	soundProfile = "spearExplosionSound";

	lifeTimeMS = 80;

	particleEmitter = RailSlugExplosionFlashEmitter;
	particleDensity = 40;
	particleRadius = 0.1;
//   emitter[0] = RailSlugExplosionEmitter;
//   emitter[1] = RailSlugLauncherExplosionFlareEmitter;

//   debris = RailSlugLauncherFlareDebris;
//   debrisNum = 50;
//   debrisNumVariance = 10;
//   debrisPhiMin = 0;
//   debrisPhiMax = 360;
//   debrisThetaMin = 0;
//   debrisThetaMax = 180;
//   debrisVelocity = 120;
//   debrisVelocityVariance = 30;
   
   faceViewer = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "5.0 5.0 4.0";
   camShakeAmp = "20.0 20.0 5.0";
   camShakeDuration = 1.0;	//0.7
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 2;
   lightStartColor = "1 0.5 0.6 1";
   lightEndColor = "1 0.5 0 0";

   damageRadius = 3;	//4
   radiusDamage = 300;

   impulseRadius = 5;
   impulseForce = 1500;
};

////////////////////////
//--Bounce Explosion--//
////////////////////////
//datablock ExplosionData(RailSlugBounceExplosion)
//{
////   explosionShape = "";
//	soundProfile = RailSlugLauncherBounceSound;

//	lifeTimeMS = 60;

//	emitter[0] = RailSlugBounceExplosionEmitter;
//	particleDensity = 60;
//	particleRadius = 0.1;
////	emitter[1] = RailSlugLauncherBounceSparkEmitter;

////   debris = RailSlugLauncherFlareDebris;
////   debrisNum = 50;
////   debrisNumVariance = 10;
////   debrisPhiMin = 0;
////   debrisPhiMax = 360;
////   debrisThetaMin = 0;
////   debrisThetaMax = 180;
////   debrisVelocity = 120;
////   debrisVelocityVariance = 30;
   
//   faceViewer = true;
//   explosionScale = "1 1 1";

//   shakeCamera = true;
//   camShakeFreq = "20.0 10.0 2.0";
//   camShakeAmp = "1.0 1.0 1.0";
//   camShakeDuration = 0.2;
//   camShakeRadius = 2.0;

//   // Dynamic light
//   lightStartRadius = 1;
//   lightEndRadius = 3;
//   lightStartColor = "1 0.5 0 1";
//   lightEndColor = "1 0.5 0 0";

//   damageRadius = 5;
//   radiusDamage = 35;

//   impulseRadius = 5;
//   impulseForce = 2000;
//};


//AddDamageType("RailSlugLauncherDirect",   '<bitmap:add-ons/Weapon_MAS_RailSlug_Launcher/CI_orb> %1',    '%2 <bitmap:add-ons/Weapon_MAS_RailSlug_Launcher/CI_orb> %1',1,1);
//AddDamageType("RailSlugLauncherRadius",   '<bitmap:add-ons/Weapon_MAS_RailSlug_Launcher/CI_orb_radius> %1',    '%2 <bitmap:add-ons/Weapon_MAS_RailSlug_Launcher/CI_orb_radius> %1',1,0);
datablock ProjectileData(RailRifleProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 100;
//   directDamageType = $DamageType::RailSlugLauncherDirect;
//   radiusDamageType = $DamageType::RailSlugLauncherRadius;
   
   impactImpulse	   = 1000;
   verticalImpulse	   = 100;
   
   explosion           = RailSlugExplosion;
//   bounceExplosion     = MASRailSlugBounceExplosion;
   particleEmitter     = RailSlugTrailEmitter;
   explodeOnDeath = false;
   explodeOnPlayerImpact = true;

   brickExplosionRadius = 1;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 4;             
   brickExplosionMaxVolume = 3;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

//   sound = RailSlugLauncherLoopSound;

   muzzleVelocity      = 200;
   velInheritFactor    = 0.4;	//0.2

   armingDelay         = 0;
   lifetime            = 3000;
   fadeDelay           = 1000;
//   bounceElasticity    = 0.999;
//   bounceFriction      = 0.1;
   isBallistic         = true;
   gravityMod = 0.4;			//0.2

   hasLight    = true;
   lightRadius = 5;
   lightColor  = "0.8 0.8 1.0";

   uiName = "MAS Rail Rifle Slug";
};

//////////
// item //
//////////
datablock ItemData(RailRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./rail_rifle3.dts";
	rotate = false;
	mass = 1;
	density = 0.2;

	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "MAS Rail Rifle";
	iconName = "./icon_railRifle";
	doColorShift = false;
	colorShiftColor = "0.100 0.500 0.250 1.000";

	 // Dynamic properties defined by the scripts
	image = RailRifleImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RailRifleImage)
{
   // Basic Item properties
   shapeFile = "./rail_rifle3.dts";
   emap = true;

   doColorShift = false;
   colorShiftColor = "0.100 0.500 0.250 1.000";

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = RailRifleItem; //Fixed this to the right item. Not so very important, but it can be the cause of a bug sometime. :)
   ammo = " ";
   projectile = RailRifleProjectile;
   projectileType = Projectile;
   
   //Raycast stuff (don't forget to add support and execute in server.cs)
   raycastWeaponRange = 96;	//128
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = RailRifleProjectile;
   raycastTracerProjectile = RailRifleProjectile;
   raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionPlayerSound = bulletHitSound;
   raycastDirectDamage = 400;
   raycastDirectDamageType = $DamageType::Generic; //$DamageType::RailSlugLauncherDirect;
   raycastSpreadAmt = 0; //Varies
   raycastFromMuzzle = true;
   //Unofficial update 4 raycast stuff
   raycastExplosionProjectileNoExplode = true;
   raycastTraceAtEnd = true;

	//casing = rocketLauncherShellDebris;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
//   minShotTime = 3000;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   //casing = " ";`

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]		 = "Ready";
	stateSound[0]					 = weaponSwitchSound;
	stateSequence[0]				 = "root";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Charge";
	stateAllowImageChange[1]         = true;
	stateSequence[1]				 = "root";

	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]     = "FullCharge";
	stateTimeoutValue[2]            = 3.45;
	stateWaitForTimeout[2]			= false;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "charge";
//	stateScript[2]                  = "onFire";
	stateEmitter[2]					= RailRifleChargeEmitter;
	stateEmitterTime[2]				= 3.45;
	stateEmitterNode[2]				= "ejectPoint";
	stateSound[2]					= radioWaveTravelSound;
	stateTransitionOnTriggerUp[2]   = "ChargeFail";

	stateName[3]					= "FullCharge";	//"I AM FULLY CHARGED" -- Medic
	stateSequence[3]                = "charged";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 1;
	stateWaitForTimeout[3]			= false;
	stateTransitionOnTimeout[3]     = "FullCharge";
	stateTransitionOnTriggerUp[3]     = "Fire";
	stateSound[3]					= RailRifleFullChargeSound;//radioWaveTravelSound;
	stateEmitter[3]					= RailRifleFullChargeEmitter;
	stateEmitterTime[3]				= 1;
	stateEmitterNode[3]				= "ejectPoint";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "Reload";
	stateTimeoutValue[4]            = 1.0;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "root";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= RailRifleMuzzleFlashEmitter;
	stateEmitterTime[4]				= 0.3;
	stateEmitterNode[4]				= "muzzleNode";
	stateSound[4]					= RailRifleFireSound;

	stateName[5]					= "Reload";
	stateSequence[5]                = "root";
	stateAllowImageChange[5]        = false;
	stateTimeoutValue[5]            = 0.1;
	stateWaitForTimeout[5]			= true;
	stateTransitionOnTimeout[5]     = "Ready";
//	stateTransitionOnTriggerUp[5]   = "Ready";

	stateName[6]					= "ChargeFail";
	stateSequence[6]                = "root";
	stateAllowImageChange[6]        = false;
	stateTimeoutValue[6]            = 0.1;
	stateWaitForTimeout[6]			= true;
	stateTransitionOnTimeout[6]     = "Ready";
//	stateTransitionOnTriggerUp[6]     = "Ready";
	stateSound[6]					= radioWaveExplosionSound;

//	stateName[4]			= "Check";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";

//	stateName[5]                    = "StopFire";
//	stateTransitionOnTimeout[5]     = "Ready";
//	stateTimeoutValue[5]            = 0.2;
//	stateAllowImageChange[5]        = false;
//	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
//	stateScript[5]                  = "onStopFire";
};

function RailRifleImage::onFire(%this,%obj,%slot)
{
	if (%obj.getDamagePercent() >= 1.0) //|| (%obj.lastFireTime+%this.minShotTime) > getSimTime()
		return;
		
	%obj.playThread(3, plant);
	%obj.playThread(2, jump);
	
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.raycastSpreadAmt = 0.0018; //Spread when moving, edit this when you want
	}
	else
	{
		%this.raycastSpreadAmt = 0;
	}
	
	%fvec = %obj.getForwardVector();
	  %fX = getWord(%fvec,0);
	  %fY = getWord(%fvec,1);
	
	%evec = %obj.getEyeVector();
	  %eX = getWord(%evec,0);
	  %eY = getWord(%evec,1);
	  %eZ = getWord(%evec,2);
	  %eXY = mSqrt(%eX*%eX+%eY*%eY);
	
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%aimVec,"-10")));
	
	Parent::onFire(%this,%obj,%slot);
	//%obj.lastFireTime = getSimTime(); //Un-comment this for usage of the minShotTime trick, don't forget to change it at the beginning too! I already gave the second half of the if, just delete the line until the ")" (")" included)
}
